<?php

function unzip($file,$dest)
{
$zip = new ZipArchive;
$res = $zip->open($file);
if($res === true)
{
	$res = $zip->extractTo($dest);
	if(!$res) return 'error: Could not extract file(s)';
	$zip->close();
	return 'OK';
}
else return 'error '.$res.': Could not open archive';
}

function oauth_getURL($url,$key,$secret)
{
	$params='oauth_consumer_key='.$key;
	$params.='&oauth_nonce='.md5(microtime() . mt_rand());
	$params.='&oauth_signature_method=HMAC-SHA1';
	$params.='&oauth_timestamp='.time();
	$params.='&oauth_version=1.0';
	$sigBase='GET&'.rawurlencode($url).'&'.rawurlencode($params);
	
	$key=rawurlencode($secret).'&';
	$sig=base64_encode(hash_hmac('sha1', $sigBase, $key, true));
	
	return $URL.'?'.$params.'&oauth_signature='.$sig;	
}

function ldap_extract($host,$rootdn,$pass,$search,$filter,$attributes='',$pagination=true)
{
	/*
		$attributes : champs à récupérer dans l'annuaire, séparés par des ;
	*/
	$ret='';
	$port=389;
	$cookie='';
	$pagesize=1000;
	$Tsearch=explode(";;",$search);
	$Tfilter=explode(";;",$filter);
	
	$i=strrpos($host,':');
	if($i!==false)
	{
		$port=substr($host,$i+1);
		$host=substr($host,0,$i);
	}

	$ds=ldap_connect($host,$port);
	if(!$ds) return 'Erreur : Impossible de contacter l\'annuaire';
	ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3);

	if ($ds) {

		$r=ldap_bind($ds,$rootdn,$pass);
		if(!$r) return 'Erreur : Identification échouée : '.ldap_error($ds);
		
		// Ouvrir fichier
		$filename=date('Ymd_His.\tx\t', time());
		$fichier = fopen($filename, 'w+');
		for($j=0;$j<count($Tsearch);$j++)
		{
			$search=$Tsearch[$j];
			if(count($Tfilter)==count($Tsearch)) $filter=$TFilter[$j];
			else $filter=$Tfilter[0];
			
			do
			{
				if($pagination) ldap_control_paged_result($ds,$pagesize,true,$cookie);
				if($attributes!='')	$sr=ldap_search($ds, $search, $filter, explode(";",$attributes));
				else $sr=ldap_search($ds, $search, $filter);
				if($sr===false) return 'Erreur : Recherche échouée : '.ldap_error($ds);
				
				$info = ldap_get_entries($ds, $sr);
				if($info===false) return 'Erreur : Impossible de récupérer les champs : '.ldap_error($ds);
				
				for ($i=0; $i<$info["count"]; $i++)
				{
					foreach($info[$i] as $key => $val)
					{
						if(!is_int($key))
						{
							if(is_array($val))
							{
								fputs($fichier, "/".$key."/:".$val[0]."\r\n");		
							}
							else
							{
								fputs($fichier, "/".$key."/:".$val."\r\n");
							}
						}
					}
					
					fputs($fichier, "/end/\r\n\r\n");
				}
				if($pagination) ldap_control_paged_result_response($ds,$sr,$cookie);
			} while ($pagination && $cookie !== null && $cookie !='');
		}

		// Fermeture du fichier
		
		fclose($fichier);
		ldap_close($ds);
		$ret=$filename;
	}
	return $ret;
}
?>